

//form field names:
//Title - text field

// *********** GLOBAL VARS *****************************

var helpDoc = "html/204.creatingdocuments.fm21.html";

// ******************** API ****************************
function canInspectSelection(){

  var titleObj = getSelectedObj();

  //accept if the selected node is text or if it is the title tag 
  return (titleObj.nodeType==Node.TEXT_NODE || (titleObj.nodeType=Node.ELEMENT_NODE && titleObj.tagName=="TITLE"));
}

function inspectSelection(){
  var titleObj = getSelectedObj();
 
  while (titleObj.nodeType!=Node.ELEMENT_NODE ) //while an element node (the title one) is not selected
    titleObj=titleObj.parentNode; //traverse up the tree	
  findObject("Title").value = titleObj.innerHTML
}


// ******************** LOCAL FUNCTIONS ****************************

function setTitleTag(){
  var titleObj = getSelectedObj();
//while an element node (the title one) is not selected
  while (titleObj.nodeType!=Node.ELEMENT_NODE ) 
    titleObj=titleObj.parentNode; //traverse up the tree	
  titleObj.innerHTML = findObject("Title").value;
}


// ******************** GENERIC FUNCTIONS ****************************


function findObject(objName,  parentObj) {
  var i,tempObj="",found=false,curObj = "";
  var NS = (navigator.appName.indexOf("Netscape") != -1);
  if (!NS && document.all) curObj = document.all[objName]; //IE4
  else {
    parentObj = (parentObj != null)? parentObj.document : document;
    if (parentObj[objName] != null) curObj = parentObj[objName]; //at top level
    else { //if in form
      if (parentObj.forms) for (i=0; i<parentObj.forms.length; i++) {  //search level for form object
        if (parentObj.forms[i][objName]) {
          curObj = parentObj.forms[i][objName];
          found = true; break;
      } }
      if (!found && NS && parentObj.layers && parentObj.layers.length > 0) {
        parentObj = parentObj.layers;
        for (i=0; i<parentObj.length; i++) { //else search for child layers
          tempObj = findObject(objName,parentObj[i]); //recurse
          if (tempObj) { curObj = tempObj; break;} //if found, done
  } } } }
  return curObj;
}

// ******************** GENERIC DOM MANIPULATION FUNCTIONS ****************************

//Returns the selected object
function getSelectedObj() {
  var selArr=dreamweaver.getSelection();
  return dreamweaver.offsetsToNode(selArr[0],selArr[1]);
}



